import type { GraphQLSchema } from 'graphql';
import ts from 'typescript';
import type { Source } from '@graphql-mesh/config';
import type { Logger, RawSourceOutput, YamlConfig } from '@graphql-mesh/types';
import type { GraphQLMeshCLIParams } from '../index.cjs';
export declare function generateTsArtifacts({ unifiedSchema, rawSources, mergerType, documents, flattenTypes, importedModulesSet, baseDir, meshConfigImportCodes, meshConfigCodes, logger, sdkConfig, fileType, codegenConfig, pollingInterval, }: {
    unifiedSchema: GraphQLSchema;
    rawSources: readonly RawSourceOutput[];
    mergerType: string;
    documents: Source[];
    flattenTypes: boolean;
    importedModulesSet: Set<string>;
    baseDir: string;
    meshConfigImportCodes: Set<string>;
    meshConfigCodes: Set<string>;
    logger: Logger;
    sdkConfig: YamlConfig.SDKConfig;
    fileType: 'ts' | 'json' | 'js';
    codegenConfig: any;
    pollingInterval?: number;
}, cliParams: GraphQLMeshCLIParams): Promise<void>;
export declare function compileTS(tsFilePath: string, module: ts.ModuleKind, outputFilePaths: string[]): void;
